Index: branches/OaaS/HeuristicLab.Clients.Hive.JobManager/3.3/HeuristicLab.Clients.Hive.JobManager-3.3.csproj
===================================================================
--- branches/OaaS/HeuristicLab.Clients.Hive.JobManager/3.3/HeuristicLab.Clients.Hive.JobManager-3.3.csproj	(revision 8956)
+++ branches/OaaS/HeuristicLab.Clients.Hive.JobManager/3.3/HeuristicLab.Clients.Hive.JobManager-3.3.csproj	(revision 8958)
@@ -82,4 +82,6 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Visualization.ChartControlsExtensions-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="System" />
     <Reference Include="System.Configuration" />
@@ -149,4 +151,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Analysis.Views\3.3\HeuristicLab.Analysis.Views-3.3.csproj">
+      <Project>{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}</Project>
+      <Name>HeuristicLab.Analysis.Views-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Clients.Hive.Views\3.3\HeuristicLab.Clients.Hive.Views-3.3.csproj">
       <Project>{E1D6C801-892A-406A-B606-F158E36DD3C3}</Project>
@@ -224,4 +230,9 @@
       <Private>False</Private>
     </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Views\RefreshableHiveJobView.resx">
+      <DependentUpon>RefreshableHiveJobView.cs</DependentUpon>
+    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: branches/OaaS/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj
===================================================================
--- branches/OaaS/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 8956)
+++ branches/OaaS/HeuristicLab.Clients.Hive.Slave/3.3/HeuristicLab.Clients.Hive.Slave-3.3.csproj	(revision 8958)
@@ -167,5 +167,7 @@
     <Compile Include="TraceCom.cs" />
     <Compile Include="WcfService.cs" />
-    <None Include="app.config" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
     <None Include="Plugin.cs.frame" />
     <Compile Include="Plugin.cs" />
Index: branches/OaaS/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginValidator.cs
===================================================================
--- branches/OaaS/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginValidator.cs	(revision 8956)
+++ branches/OaaS/HeuristicLab.PluginInfrastructure/3.3/Manager/PluginValidator.cs	(revision 8958)
@@ -488,4 +488,11 @@
     }
 
+    private string AssemblyDirectory(Assembly assem) {
+      string codeBase = assem.CodeBase;
+      UriBuilder uri = new UriBuilder(codeBase);
+      string path = Uri.UnescapeDataString(uri.Path);
+      return Path.GetFullPath(path);      
+    }
+
 
     private bool IsAnyDependencyDisabled(PluginDescription descr, List<PluginDescription> disabledPlugins) {
@@ -512,5 +519,6 @@
             try {
               string assemblyName = (from assembly in AppDomain.CurrentDomain.ReflectionOnlyGetAssemblies()
-                                     where string.Equals(Path.GetFullPath(assembly.Location), Path.GetFullPath(assemblyLocation), StringComparison.CurrentCultureIgnoreCase)
+                                     where string.Equals(Path.GetFullPath(assembly.Location), Path.GetFullPath(assemblyLocation), StringComparison.CurrentCultureIgnoreCase) ||
+                                           string.Equals(AssemblyDirectory(assembly), Path.GetFullPath(assemblyLocation), StringComparison.CurrentCultureIgnoreCase)
                                      select assembly.FullName).Single();
               // now load the assemblies into the execution context  
Index: branches/OaaS/HeuristicLab.PluginInfrastructure/3.3/WebApplicationManager.cs
===================================================================
--- branches/OaaS/HeuristicLab.PluginInfrastructure/3.3/WebApplicationManager.cs	(revision 8956)
+++ branches/OaaS/HeuristicLab.PluginInfrastructure/3.3/WebApplicationManager.cs	(revision 8958)
@@ -88,4 +88,12 @@
     }
 
+    static private string AssemblyDirectory {
+      get {
+        string codeBase = Assembly.GetExecutingAssembly().CodeBase;
+        UriBuilder uri = new UriBuilder(codeBase);
+        string path = Uri.UnescapeDataString(uri.Path);
+        return Path.GetDirectoryName(path);
+      }
+    }
     // find all types implementing IPlugin in the reflectionOnlyAssemblies and create a list of plugin descriptions
     // the dependencies in the plugin descriptions are not yet set correctly because we need to create
@@ -93,6 +101,32 @@
     private List<PluginDescription> GatherPluginDescriptions()
     {
-      List<PluginDescription> pluginDescriptions = new List<PluginDescription>();
-      foreach (Assembly assembly in AppDomain.CurrentDomain.GetAssemblies())
+      /*List<PluginDescription> pluginDescriptions = new List<PluginDescription>();
+
+      // load all assemblies that are available in the project folders
+      var loadedAssemblies = AppDomain.CurrentDomain.GetAssemblies().ToList();
+      IList<string> loadedPaths = new List<string>();
+      foreach (var asm in loadedAssemblies) {
+        try {
+          loadedPaths.Add(asm.Location);
+        }
+        catch (Exception ex) {
+        }
+      }*/
+      /*var assembliePaths = from location in loadedAssemblies                           
+                           select location.Location;
+
+      var loadedPaths = loadedAssemblies.Select(a => a.Location).ToArray();*/
+      var pv = new PluginValidator() { PluginDir = AssemblyDirectory };
+      pv.DiscoverAndCheckPlugins();
+      return pv.Plugins.ToList();
+      /*var pluginManager = new PluginManager(AssemblyDirectory);
+      pluginManager.DiscoverAndCheckPlugins();
+      return pluginManager.Plugins.ToList();*/
+
+      /*var referencedPaths = Directory.GetFiles(AssemblyDirectory, "*.dll");
+      var toLoad = referencedPaths.Where(r => !loadedPaths.Contains(r, StringComparer.InvariantCultureIgnoreCase)).ToList();
+      toLoad.ForEach(path => loadedAssemblies.Add(AppDomain.CurrentDomain.Load(AssemblyName.GetAssemblyName(path))));
+      
+      foreach (Assembly assembly in loadedAssemblies)
       {
         // GetExportedTypes throws FileNotFoundException when a referenced assembly
@@ -106,4 +140,6 @@
                                            where !t.IsAbstract && t.GetInterfaces().Any(x => x.AssemblyQualifiedName == typeof(IPlugin).AssemblyQualifiedName)
                                            select GetPluginDescription(t);
+
+          // TODO: Also load all plugin descriptors from assemblies liying in the app domain folder!!!!!
           pluginDescriptions.AddRange(assemblyPluginDescriptions);
         }
@@ -122,5 +158,5 @@
         }
       }
-      return pluginDescriptions;
+      return pluginDescriptions;*/
     }
 
Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 8958)
@@ -0,0 +1,132 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Services.Optimization.ControllerService.Interfaces;
+using Microsoft.WindowsAzure;
+using Microsoft.WindowsAzure.StorageClient;
+
+namespace HeuristicLab.Services.Optimization.ControllerService.Azure {
+  public static class AzureConstants {
+    public static readonly string SCENARIO_TABLE = "Scenario";
+    public static readonly string SCENARIO_BLOB_CONTAINER = "scenario";
+    public static readonly string CLOUD_SETTINGS_KEY = "Cloudia.WindowsAzure.Storage";
+  }
+
+  public class ScenarioDao : IScenarioDao {    
+    public CloudTableClient TableClient { get; set; }
+
+    public bool Add(ScenarioEntity entity) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.SCENARIO_TABLE);
+      ScenarioEntity dbEntity = (from e in serviceContext.CreateQuery<ScenarioEntity>(AzureConstants.SCENARIO_TABLE)
+                               where e.RowKey == entity.RowKey
+                               select e).FirstOrDefault();
+      if (dbEntity != null)
+        return false;
+
+      serviceContext.AddObject(AzureConstants.SCENARIO_TABLE, entity);
+      serviceContext.SaveChanges();
+      return true;
+    }
+
+    public bool DeleteByName(string scenarioName) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.SCENARIO_TABLE);
+      ScenarioEntity entity = (from e in serviceContext.CreateQuery<ScenarioEntity>(AzureConstants.SCENARIO_TABLE)
+                               where e.RowKey == scenarioName
+                               select e).FirstOrDefault();
+      if (entity == null)
+        return false;
+
+      serviceContext.DeleteObject(entity);
+      serviceContext.SaveChangesWithRetries();
+      return true;
+    }
+
+    public ScenarioEntity FindByName(string scenarioName) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.SCENARIO_TABLE);
+      ScenarioEntity entity = (from e in serviceContext.CreateQuery<ScenarioEntity>(AzureConstants.SCENARIO_TABLE)
+                               where e.RowKey == scenarioName
+                               select e).FirstOrDefault();
+      return entity;
+    }
+
+
+    public IEnumerable<ScenarioEntity> GetAllEntities() {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.SCENARIO_TABLE);
+      return (from e in serviceContext.CreateQuery<ScenarioEntity>(AzureConstants.SCENARIO_TABLE)
+             select e).AsEnumerable();
+    }
+  }
+
+  public class BlobDao : IBlobDao {
+    public CloudBlobClient BlobClient { get; set; }
+
+    public bool Add(StringEntry entry) {
+      CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.SCENARIO_BLOB_CONTAINER);
+      container.CreateIfNotExist();
+      var blob = container.GetBlobReference(entry.Key);
+      blob.UploadText(entry.Text);
+      return true;
+    }
+
+    public bool DeleteByKey(string entryKey) {
+      CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.SCENARIO_BLOB_CONTAINER);
+      container.CreateIfNotExist();
+      var blob = container.GetBlobReference(entryKey);
+      return blob.DeleteIfExists();
+    }
+
+    public StringEntry FindByKey(string entryKey) {
+      CloudBlobContainer container = BlobClient.GetContainerReference(AzureConstants.SCENARIO_BLOB_CONTAINER);
+      container.CreateIfNotExist();
+      var blob = container.GetBlobReference(entryKey);
+      return new StringEntry() { Key = entryKey, Text = blob.DownloadText() };      
+    }
+  }
+
+  public class AzureDataAccessLayer : IDataAccessLayer {
+    private IScenarioDao scenarioDao;
+    private IBlobDao blobDao;
+
+    private CloudStorageAccount storageAccount;
+
+    private CloudStorageAccount StorageAccount {
+      get {
+        if (storageAccount == null) {
+          storageAccount = CloudStorageAccount.Parse(CloudConfigurationManager.GetSetting(AzureConstants.CLOUD_SETTINGS_KEY));
+        }
+        return storageAccount; 
+      }      
+    }
+
+    public IScenarioDao ScenarioDao {
+      get {
+        if (scenarioDao == null) {
+          scenarioDao = new ScenarioDao();
+        }
+        return scenarioDao;
+      }
+    }
+
+    public IBlobDao BlobDao {
+      get {
+        if (blobDao == null) {
+          blobDao = new BlobDao();
+        }
+        return blobDao;
+      }
+    }
+
+    public IScenarioDao CreateScenarioDao() {
+      return new ScenarioDao() { TableClient = StorageAccount.CreateCloudTableClient() };
+    }
+
+    public IBlobDao CreateBlobDao() {
+      return new BlobDao() { BlobClient = StorageAccount.CreateCloudBlobClient() };
+    }
+  }
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HLMapper.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HLMapper.cs	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HLMapper.cs	(revision 8958)
@@ -0,0 +1,68 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+using HeuristicLab.Optimization;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Services.Optimization.ControllerService {
+  public interface IScenarioMapper {
+    void MapScenario(OptimizationScenario scenario, IAlgorithm algorithm);
+  }
+
+  public static class HLMapper {
+    public static DoubleValue ConvertToDoubleValue(Parameter parameter) {
+      var dv = parameter.Value as DecimalValue;
+      return new DoubleValue(dv.Value);      
+    }
+
+    public static Permutation ConvertToPermutation(Parameter parameter) {
+      double[] input = (parameter.Value as DecimalVector).Value;
+      int[] arr = new int[input.Length];
+      for (int i = 0; i < input.Length; i++) {
+        arr[i] = Convert.ToInt32(input[i]);
+      }
+      var valueObj = new HeuristicLab.Encodings.PermutationEncoding.Permutation(Encodings.PermutationEncoding.PermutationTypes.RelativeUndirected, arr);
+      return valueObj;
+    }
+
+    public static DoubleMatrix ConvertToDoubleMatrix(Parameter parameter) {
+      var matrix = parameter.Value as DecimalMatrix;
+      // TODO: Check for empty matrices
+      double[,] data = new double[matrix.Value.Length, matrix.Value[0].Length];
+      for (int i=0; i < matrix.Value.Length; i++) {
+        for (int j=0; j < matrix.Value[i].Length; j++) {
+          data[i,j] = matrix.Value[i][j];
+        }
+      }
+      return new DoubleMatrix(data);
+    }
+
+    public static HeuristicLab.Data.BoolValue ConvertToBoolValue(Parameter parameter) {
+      return new HeuristicLab.Data.BoolValue((parameter.Value as HeuristicLab.Services.Optimization.ControllerService.Model.BoolValue).Value);
+    }
+
+    public static IntValue ConvertToIntValue(Parameter parameter) {
+      return new IntValue((int)(parameter.Value as DecimalValue).Value);
+    }
+
+    public static PercentValue ConvertToPercentValue(Parameter parameter) {
+      return new PercentValue((parameter.Value as DecimalValue).Value / 100);
+    }
+
+    public static string GetStringValue(Parameter parameter) {
+      return (parameter.Value as HeuristicLab.Services.Optimization.ControllerService.Model.TypeValue).Value;
+    }
+
+    public static T FindInItemSet<T>(Core.IItemSet<T> items, Parameter what) where T : class,Core.INamedItem {
+      return items.FirstOrDefault((entry) => { return entry.Name == (what.Value as HeuristicLab.Services.Optimization.ControllerService.Model.TypeValue).Value; });
+    }
+
+    public static T FindOperator<T>(IProblem problem, Parameter what) where T : IOperator {
+      return problem.Operators.OfType<T>().FirstOrDefault((item) => { return item.ItemName == (what.Value as HeuristicLab.Services.Optimization.ControllerService.Model.TypeValue).Value; });
+    }
+  }
+}
Index: branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveMapper.cs
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveMapper.cs	(revision 8958)
+++ branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveMapper.cs	(revision 8958)
@@ -0,0 +1,20 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Services.Optimization.ControllerService.Model {
+  public static class HiveMapper {    
+    public static double FindDoubleValue(this InputParameters ip, string what) {     
+      foreach (var param in ip.Items) {
+        if (param.Value.Name == what) {
+          var dv = param.Value as DecimalValue;
+          //DoubleValue result = new DoubleValue(dv.Value);
+          return dv.Value;
+        }
+      }
+      return 0.0;
+    }
+  }
+}
